<template>
    <section>
        <button id="ButtonSidebar" class="right menuButton" @click="toggleMenu">☰</button>

        <Header></Header>

        <div class="rightMenu" v-show="displayMenu">
            <div v-if="menuComponent === ''">
                <span>MENU</span>
                <hr>
                <a class="menuActionButton" @click="menuComponent = 'epreuves'">Epreuves</a>
                <a class="menuActionButton" @click="menuComponent = 'dossards'">Dossards de l'épreuve</a>
            </div>

            <template v-else-if="menuComponent === 'epreuves'">
                <EpreuveList></EpreuveList>
            </template>

            <template v-else-if="menuComponent === 'dossards'">
                <DossardList></DossardList>
            </template>
        </div>

        <div class="header">
            <span class="title center">{{title}}</span>
        </div>

        <table v-if="data !== null">
            <tr>
            <tr>
                <td></td>
                <td>Dossard</td>
                <td v-if="typeof dossard === 'undefined'">Unknown</td>
                <td v-else>{{dossard}}</td>
            </tr>

            <template v-for="(criteres, parent) in data.notations">
                <tr>
                    <td>{{parent}}</td>
                    <td></td>
                    <td></td>
                </tr>
                <tr v-for="(value, critere) in criteres">
                    <td class="critere">{{critere}}</td>
                    <td class="center">{{value}}</td>
                    <td :class="critereChecked[parent] === critere ? 'checked' : ''" @click="checkCell(parent, critere)"></td>
                </tr>
                <tr>
                    <td></td>
                    <td class="center">Total {{parent|FirstLetter}}</td>
                    <td v-if="critereChecked[parent]">{{criteres[critereChecked[parent]]}}</td>
                </tr>
            </template>

            <tr>
                <td></td>
                <td class="center">Total</td>
                <td>{{getTotal()}}</td>
            </tr>

            <tr>
                <td>Observations</td>
                <td>{{data.Observation}}</td>
                <td class="noPadding"><textarea v-model="observations" @blur="observationBlur" class="observationInput" maxlength="255" cols="40" rows="5"></textarea></td>
            </tr>

            <template v-for="(penal, parent) in data.penalites">
                <tr>
                    <td>{{parent}}</td>
                    <td></td>
                    <td></td>
                </tr>
                <tr v-for="(value, pen) in penal">
                    <td class="critere">{{pen}}</td>
                    <td>{{value}}</td>
                    <td :class="critereChecked[pen] === true ? 'checked' : ''" @click="checkCell(pen)"></td>
                </tr>
            </template>
            <tr v-for="(value, critere) in data.others">
                <td>{{critere}}</td>
                <td class="center">{{value}}</td>
                <td></td>
            </tr>
        </table>
        <h2 class="center" v-else>Chargement de l'épreuve</h2>
    </section>
</template>

<script>
    import config from "../../js/config.js";
    import Header from "../components/Header.vue";
    import DossardList from "../components/DossardList.vue";
    import EpreuveList from "../components/EpreuveList.vue";
    import axios from "axios";

    export default {
        name: "Notes",
        components: {
            Header: Header,
            DossardList: DossardList,
            EpreuveList: EpreuveList
        },
        data: function () {
            return {
                data: null,
                title: '',
                dossard: '',
                epreuve: '',
                critereChecked: {},
                displayMenu: false,
                menuComponent: '',
                observations: '',
                bdd: null
            };
        },
        created() {
            this.bdd = this.$parent.bddlocale;
            let params = this.$parent.params;
            this.dossard = params.dossard;
            this.epreuve = params.epreuve;
            this.loadEpreuve();
        },
        bddLoaded() {
            // console.log("test");
        },
        methods: {
            saveData() {
                axios
                    .post('https://'+config.host+'/updatecompetition', {
                        idepreuve: this.epreuve,
                        iddossard: this.dossard,
                        criteres: JSON.stringify(this.critereChecked),
                        note: this.getTotal(),
                        observations: this.observations
                    })
                    .catch(error => {
                        console.log(error);
                    })
            },
            loadEpreuve() {
                axios
                    .get('https://'+config.host+'/listeepreuves/'+this.epreuve)
                    .then(response => {
                        let data = response.data;
                        if(data){
                            let name = data[0].nom;
                            this.title = name;
                            let structure = name.toLowerCase().replace(/ /g, '_')+'.json';
                            import('../../data/notations/'+structure)
                                .then(epreuveData => {
                                    this.data = epreuveData.default;
                                    this.loadData()
                                });
                        }
                    })
                    .catch(error => {
                        console.log(error);
                    })
            },
            loadData() {
                if (typeof this.epreuve === 'undefined') {
                    this.toggleMenu();
                    this.menuComponent = 'epreuves';
                } else if (typeof this.dossard === 'undefined') {
                    this.toggleMenu();
                    this.menuComponent = 'dossards';
                } else {
                    axios
                        .get('https://'+config.host+'/donneesdossard/'+this.epreuve+'/'+this.dossard)
                        .then(response => {
                            let data = response.data;
                            if(data){
                                if(data.criteres !== null)
                                {
                                    this.critereChecked = JSON.parse(data.criteres);
                                }
                                if(data.criteres !== null)
                                {
                                    this.observations = data.observations;
                                }
                            }
                        })
                        .catch(error => {
                            console.log(error);
                        })
                }
            },
            toggleMenu() {
                this.menuComponent = '';
                this.displayMenu = !this.displayMenu;
            },
            observationBlur() {
                this.saveData();
            },
            checkCell(parent, critere=null) {
                if(typeof this.epreuve === 'undefined' || typeof this.dossard === 'undefined')
                {
                    return;
                }
                if(critere === null)
                {
                    if(this.critereChecked[parent] === true)
                    {
                        delete this.critereChecked[parent];
                    }else{
                        this.critereChecked[parent] = true;
                    }
                }else{
                    if (this.critereChecked[parent] === critere) {
                        delete this.critereChecked[parent];
                    } else {
                        this.critereChecked[parent] = critere;
                    }
                }
                this.$forceUpdate();
                this.saveData();
            },
            getTotal() {
                let sum = 0;
                let critereList = this.critereChecked;
                let dataList = this.data.notations;
                Object.keys(critereList).map(function (parent) {
                    if(critereList[parent] === true)
                    {
                        sum = 0;
                        return;
                    }
                    let value = dataList[parent][critereList[parent]];
                    sum += value;
                });
                return sum;
            }
        },
        filters: {
            FirstLetter(critereName) {
                return critereName.substr(0, 1).toUpperCase();
            }
        }
    };
</script>

<style>
    body, html {
        width: 100%;
        margin: 0;
    }

    .header {
        display: flex;
    }

    .noPadding {
        padding: 0;
        width: 30%;
    }

    .observationInput {
        width: 100%;
        height: 100%;
        border: none;
        font-size: 1vw;
        resize: none;
    }

    .title {
        display: block;
        width: 100%;
        text-transform: uppercase;
    }

    .checked {
        background-image: linear-gradient(
                to top left,
                white 48%,
                black,
                white 52%
        )
    }

    .critereParent {
        color: darkgreen;
    }

    table, td, th {
        border: 1px solid #ddd;
        text-align: left;
    }

    table {
        border-collapse: collapse;
        width: 100%;
        margin-top: 2%;
    }

    th, td {
        padding: 15px;
    }

    .critere {
        padding-left: 5%;
    }

    .center {
        text-align: center;
    }

    .right {
        right: 0;
    }

    .menuButton {
        margin: 1% 4% 1% 1%;
        position: fixed;
        font-size: 1em;
    }

    .rightMenu {
        display: block;
        position: fixed;
        z-index: 10;
        width: 50%;
        height: 80%;
        right: 0;
        background-color: rgb(24, 26, 27);
        animation: animateright 0.4s;
    }

    .menuActionButton:hover {
        color: rgb(232, 230, 227);
        background-color: rgb(39, 41, 43);
    }

    .menuActionButton, .rightMenu span {
        display: block;
        padding: 8px 16px;
        border: none currentcolor;
        white-space: normal;
        float: none;
        text-align: center;
        color: white;
        text-decoration: none;
    }
</style>